﻿Imports System.Web.Http
Imports Breeze.WebApi
Imports BreezyDevices.Models
Imports Newtonsoft.Json.Linq

Namespace BreezyDevices.Controllers
    Public Class BreezyDevicescontroller
        Inherits ApiController

        Private ReadOnly _contextProvider As New EFContextProvider(Of BreezyDevicesContext)

        ' ~/api/breezydevices/Metadata 
        <AcceptVerbs("GET")>
        Public Function Metadata() As String
            Return _contextProvider.Metadata
        End Function

        ' ~/api/breezydevices/SaveChanges
        <AcceptVerbs("POST")>
        Public Function SaveChanges(ByVal saveBundle As JObject) As SaveResult
            Return _contextProvider.SaveChanges(saveBundle)
        End Function


        ' ~/api/breezydevices/people
        ' ~/api/breezydevices/people?$filter=LastName%20startswith%20L&$orderby=LastName 
        <AcceptVerbs("GET")>
        Public Function People() As IQueryable(Of Person)
            Return _contextProvider.Context.People
        End Function

        ' ~/api/breezydevices/devices
        <AcceptVerbs("GET")>
        Public Function Devices() As IQueryable(Of Device)
            Return _contextProvider.Context.Devices
        End Function


        ' ~/api/breezydevices/reset
        <AcceptVerbs("POST")>
        Public Function Reset() As String
            BreezyDevicesDatabaseInitializer.ResetDatabase(_contextProvider.Context)
            Return "reset"
        End Function
    End Class
End Namespace