﻿Imports System.Data.Entity
' ReSharper disable RedundantAssignment

Namespace BreezyDevices.Models
    Public Class BreezyDevicesDatabaseInitializer
        Inherits DropCreateDatabaseIfModelChanges(Of BreezyDevicesContext)
        'DropCreateDatabaseAlways<BreezyDevicesContext>
        Protected Overrides Sub Seed(ByVal context As BreezyDevicesContext)
            SeedDatabase(context)
        End Sub

        Public Shared Sub ResetDatabase(ByVal context As BreezyDevicesContext)
            PurgeDatabase(context)
            SeedDatabase(context)
        End Sub

        Public Shared Sub PurgeDatabase(ByVal context As BreezyDevicesContext)
            Dim devices = context.Devices.ToList
            For Each device In devices
                context.Devices.Remove(device)
            Next device
            Dim people = context.People.ToList
            For Each person In people
                context.People.Remove(person)
            Next person
            context.SaveChanges()
        End Sub

        Public Shared Sub SeedDatabase(ByVal context As BreezyDevicesContext)
            Dim persons = New List(Of Person)
            Dim devices = New List(Of Device)
            Dim personId = 0
            Dim deviceId = 0

            personId += 1
            persons.Add(New Person With {.FirstName = "Julie", .LastName = "Lerman", .IdentityCardNumber = "12345", .PersonId = personId})
            devices.AddRange({New Device With {.DeviceName = "IPad", .DeviceId = ++deviceId, .PersonId = personId}, New Device With {.DeviceName = "Nokia Lumia 900", .DeviceId = ++deviceId, .PersonId = personId}})

            personId += 1
            persons.Add(New Person With {.FirstName = "Sampson", .LastName = "Lerman", .IdentityCardNumber = "woof", .PersonId = personId})
            devices.AddRange({New Device With {.DeviceName = "leash", .DeviceId = ++deviceId, .PersonId = personId}, New Device With {.DeviceName = "slobber towel", .DeviceId = ++deviceId, .PersonId = personId}})

            personId += 1
            persons.Add(New Person With {.FirstName = "Ward", .LastName = "Bell", .IdentityCardNumber = "IdeaBlade", .PersonId = personId})
            devices.AddRange({New Device With {.DeviceName = "Giotto Evoluzione", .DeviceId = ++deviceId, .PersonId = personId}, New Device With {.DeviceName = "Windows 8 Build Tablet", .DeviceId = ++deviceId, .PersonId = personId}})

            persons.ForEach(Function(p) context.People.Add(p))
            devices.ForEach(Function(d) context.Devices.Add(d))
            context.SaveChanges() ' Save 'em
        End Sub

    End Class
End Namespace